extension ExString on String {
  /// 逗号分隔的图片转 StringList
  List<String> xSplit([Pattern? pattern]) {
    if (isEmpty) return [];
    return split(pattern ?? ',');
  }

  /// 显示隐藏中间四位的手机号
  String hidePhone() {
    if (length == 11) {
      return substring(0, 3) + '****' + substring(7);
    } else {
      return this;
    }
  }

  /// 转为 int
  int toInt([int? defaultInt]) {
    return int.tryParse(this) ?? (defaultInt ?? 0);
  }

  /// 转为 double
  double toDouble([double? defaultDouble]) {
    return double.tryParse(this) ?? (defaultDouble ?? 0.0);
  }
}
