import 'package:dio/dio.dart';
import 'package:hgg_base/hgg_base.dart';

export 'package:dio/dio.dart';

///API拦截器
class ApiOnError extends InterceptorsWrapper {
  final bool showLog;

  ApiOnError({this.showLog = false});

  /// 网络相关错误
  @override
  void onError(DioError err, ErrorInterceptorHandler handler) {
    if (err.response == null) {
      XLog.e(err.message, '###空Response错误### uri:${err.requestOptions.path}');
      return handler.reject(err);
    }
    int? statusCode = err.response?.statusCode;
    String? errorMsg = err.response?.statusMessage;
    switch (statusCode) {
      default:
        errorMsg = 'code:$statusCode\n$errorMsg';
        break;
    }
    XLog.e(err.response, '###非200错误###');
    return handler.reject(err);
  }
}
