import 'package:dio/dio.dart';
import 'package:hgg_base/hgg_base.dart';

export 'package:dio/dio.dart';

///API拦截器
class ApiOnRequest extends InterceptorsWrapper {
  final bool showLog;

  ApiOnRequest({this.showLog = false});

  @override
  void onRequest(RequestOptions options, RequestInterceptorHandler handler) {
    var requestUrl = options.baseUrl + options.path;
    var urlAndInfo = requestUrl.xSplit('?');

    Map<String, dynamic> showInfo = {
      'method': '###${options.method}###',
      'path': urlAndInfo[0],
    };
    if (urlAndInfo.length > 1) {
      showInfo['info'] = urlAndInfo[1];
    }

    showInfo['Header信息'] = options.headers;
    if (options.queryParameters.isNotEmpty) {
      showInfo['query'] = options.queryParameters;
    }
    if (options.data != null) {
      showInfo['data'] = options.data;
    }
    if (showLog) XLog.i(showInfo);

    return handler.next(options);
  }
}
